# Contributing to flashlight
flashlight is still under development; we appreciate any contributions.

## Pull Requests
We actively welcome your pull requests.

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs, update [and build](docs/README.md) the documentation (to check correctness - don't submit built documentation).
4. Ensure the test suite passes.
5. Make sure your code lints and run `clang-format` given the provided configuration.
6. If you haven't already, complete the Contributor License Agreement ("CLA").

## Contributor License Agreement ("CLA")
All contributors must sign the CLA for their pull requests to be eligible for merge. One only needs to do this once to contribute to any of Facebook's open source projects.

You can find the CLA [here](https://code.facebook.com/cla).

## Issues
We use [GitHub issues](https://github.com/facebookresearch/flashlight/issues) to track public bugs. When filing, a bug, please make sure your description is clear and include sufficient instructions to reproduce the issue (for instance, your OS, compiler version, and selected backend).

## License
By contributing to flashlight, you agree that your contributions will be licensed
under the LICENSE file in the root directory of this source tree.
